<?php

namespace Drupal\entity_model;

use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;
use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\entity_model\Annotation\Model;

class ModelPluginManager extends DefaultPluginManager
{
    public function __construct(
        \Traversable $namespaces,
        CacheBackendInterface $cacheBackend,
        ModuleHandlerInterface $moduleHandler
    ) {
        parent::__construct(
            'Entity',
            $namespaces,
            $moduleHandler,
            ContentEntityInterface::class,
            Model::class
        );
        $this->alterInfo('entity_model_model_info');
        $this->setCacheBackend($cacheBackend, 'entity_model_model_info_plugins');
    }
}
